Kea: isc::yang::TranslatorOptionDef Class Reference

| Kea 3.2.0-git

isc::yang::TranslatorOptionDef Class Reference

Option definition translation between YANG and JSON. More...

`#include <translator_option_def.h>`

Inheritance diagram for isc::yang::TranslatorOptionDef:
[legend]

## Public Member Functions
| TranslatorOptionDef (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionDef ()=default
| Destructor.
isc::data::ElementPtr | getOptionDef (libyang::DataNode const &data_node)
| Translate an option definition from YANG to JSON.
isc::data::ElementPtr | getOptionDefFromAbsoluteXpath (std::string const &xpath)
| Translate an option definition from YANG to JSON.
void | setOptionDef (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option definition from JSON to YANG.
Public Member Functions inherited from isc::yang::Translator
| Translator (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~Translator ()=default
| Destructor.
template<typename T>
void | checkAndGet (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {xpath} key.
void | checkAndGetAndJsonifyLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, const std::string &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node, converts it from string to JSON and stores it in the specified storage.
template<typename T>
void | checkAndGetDiverging (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &key, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {key} key.
void | checkAndGetDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndGetLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndSetDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeafList (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath as a leaf-list.
void | checkAndSetUserContext (isc::data::ConstElementPtr const &from, std::string const &xpath)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndStringifyAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | deleteItem (const std::string &xpath)
| Delete basic value from YANG.
libyang::DataNode | findXPath (std::string const &xpath) const
| Retrieves a YANG data node by xpath.
template<typename functor_t>
void | forAll (std::string const &xpath, functor_t f) const
| Run a function for a node and all its children.
std::optional< libyang::DataNode > | getData (std::string const &xpath) const
| Get a YANG data node found at the given absolute xpath.
isc::data::ElementPtr | getItem (libyang::DataNode const &data_node, std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given xpath that is relative to the given source node.
isc::data::ElementPtr | getItemFromAbsoluteXpath (std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given absolute xpath.
template<typename T>
isc::data::ElementPtr | getList (libyang::DataNode const &data_node, std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(libyang::DataNode const &)) const
| Retrieve a list as ElementPtr from sysrepo from a certain xpath.
void | getMandatoryDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by one name from the given parent YANG container node and stores it in the specified storage under a different name.
void | getMandatoryLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
bool | schemaNodeExists (std::string const &xpath) const
| Checks whether a YANG node exists in the schema.
void | setItem (const std::string &xpath, isc::data::ConstElementPtr const elem, libyang::LeafBaseType const type)
| Translate and set basic value from JSON to YANG.
void | setMandatoryDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | setMandatoryLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.

## Protected Member Functions
isc::data::ElementPtr | getOptionDefKea (libyang::DataNode const &data_node)
| getOptionDef implementation specific to kea-dhcp[46]-server models.
void | setOptionDefKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionDef implementation specific to kea-dhcp[46]-server models.

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::Translator
static isc::data::ElementPtr | translateFromYang (std::optional< libyang::DataNode > data_node)
| Translate basic value from the given YANG data node to JSON element.
static std::optional< std::string > | translateToYang (isc::data::ConstElementPtr const &elem, libyang::LeafBaseType const type)
| Translate basic value from JSON to YANG.
Protected Types inherited from isc::yang::Translator
using | Deserializer
| Maps YANG types to functions that transform a YANG type into an ElementPtr.
using | Serializer
| Maps YANG types to functions that transform the string representation of an Element into a string that can be passed into Session::setItem().
Static Protected Member Functions inherited from isc::yang::Translator
static std::string | decode64 (std::string const &input)
| Decode a YANG element of binary type to a string that can be stored in an Element::string JSON.
static std::string | encode64 (std::string const &input)
| Encode a string such that it can be stored in a YANG element of binary type.
static Deserializer | initializeDeserializer ()
| Initializes the deserializer which is used to translate a YANG node to an ElementPtr.
static Serializer | initializeSerializer ()
| Initializes the serializer which is used to translate the string value of an Element to a string that can be passed into Session::setItem().
Protected Attributes inherited from isc::yang::Translator
std::string | model_
| The model.
sysrepo::Session | session_
| The sysrepo session.

## Detailed Description

Option definition translation between YANG and JSON.

JSON syntax for Kea DHCP servers is:

{
"code": <code>,
"name": <name>,
"space": <space>,
"type": <type>,
"array": <array flag>,
"encapsulate": <encapsulated space>,
"record-types": <record types>,
"user-context": { <json map> },
"comment": "<comment>"
}

YANG syntax for kea-dhcp[46] with code and space as keys is:

+--rw option-def* [code space]
+--rw code uint8
+--rw space string
+--rw name string
+--rw type string
+--rw record-types? string
+--rw encapsulate? string
+--rw array? boolean
+--rw user-context? user-context

An example in JSON and YANG formats:

[
{
"code": 100,
"name": "foo",
"space": "isc",
"type": "string",
"array": false
}
]
/kea-dhcp6-server:config (container)
/kea-dhcp6-server:config/
option-def[code='100'][space='isc'] (list instance)
/kea-dhcp6-server:config/
option-def[code='100'][space='isc']/code = 100
/kea-dhcp6-server:config/
option-def[code='100'][space='isc']/space = isc
/kea-dhcp6-server:config/
option-def[code='100'][space='isc']/name = foo
/kea-dhcp6-server:config/
option-def[code='100'][space='isc']/type = string
/kea-dhcp6-server:config/
option-def[code='100'][space='isc']/array = false
string
STL class.
isc::config
Definition command_interpreter.cc:23
isc
Defines the logger used by the top-level component of kea-lfc.
Definition check_exists_add.cc:18

A translator class for converting an option definition between YANG and JSON.

Currently supports kea-dhcp[46]-server models.

Todo
  : Support for ietf-dhcpv6-server model.

Definition at line 78 of file translator_option_def.h.

## Constructor & Destructor Documentation

## ◆ TranslatorOptionDef()

isc::yang::TranslatorOptionDef::TranslatorOptionDef | ( | sysrepo::Session | session,
|  | const std::string & | model )

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 22 of file translator_option_def.cc.

References isc::yang::Translator::Translator().

Referenced by isc::yang::TranslatorOptionDefList::TranslatorOptionDefList().

Here is the call graph for this function:

## ◆ ~TranslatorOptionDef()

virtual isc::yang::TranslatorOptionDef::~TranslatorOptionDef | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getOptionDef()

ElementPtr isc::yang::TranslatorOptionDef::getOptionDef | ( | libyang::DataNode const & | data_node | ) |

Translate an option definition from YANG to JSON.

Parameters

  data_node | the YANG node representing the option definition

Returns
  the JSON representation of the option definition

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 28 of file translator_option_def.cc.

References getOptionDefKea(), isc_throw, isc::yang::Translator::model_, and isc::Exception::what().

Referenced by getOptionDefFromAbsoluteXpath(), and isc::yang::TranslatorOptionDefList::getOptionDefListKea().

Here is the call graph for this function:

## ◆ getOptionDefFromAbsoluteXpath()

ElementPtr isc::yang::TranslatorOptionDef::getOptionDefFromAbsoluteXpath | ( | std::string const & | xpath | ) |

Translate an option definition from YANG to JSON.

Parameters

  xpath | The xpath of the option definition.

Returns
  JSON representation of the option definition.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 44 of file translator_option_def.cc.

References isc::yang::Translator::findXPath(), and getOptionDef().

Here is the call graph for this function:

## ◆ getOptionDefKea()

ElementPtr isc::yang::TranslatorOptionDef::getOptionDefKea | ( | libyang::DataNode const & | data_node | ) |
| protected

getOptionDef implementation specific to kea-dhcp[46]-server models.

Parameters

  data_node | the YANG node representing the option definition

Returns
  JSON representation of the option definition.

Exceptions

  NetconfError | when sysrepo raises an error.
  BadValue | on option definition without name or type.

Definition at line 53 of file translator_option_def.cc.

References isc::yang::Translator::checkAndGetAndJsonifyLeaf(), isc::yang::Translator::checkAndGetLeaf(), Element::createMap(), and isc::yang::Translator::getMandatoryLeaf().

Referenced by getOptionDef().

Here is the call graph for this function:

## ◆ setOptionDef()

void isc::yang::TranslatorOptionDef::setOptionDef | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )

Translate and set option definition from JSON to YANG.

Parameters

  xpath | The xpath of the option definition..
  elem | The JSON element.

Definition at line 71 of file translator_option_def.cc.

References isc_throw, isc::yang::Translator::model_, setOptionDefKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorOptionDefList::setOptionDefListKea().

Here is the call graph for this function:

## ◆ setOptionDefKea()

void isc::yang::TranslatorOptionDef::setOptionDefKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setOptionDef implementation specific to kea-dhcp[46]-server models.

Parameters

  xpath | The xpath of the option definition.
  elem | The JSON element.

Exceptions

  BadValue | on option definition without name or type.

Definition at line 89 of file translator_option_def.cc.

References isc::yang::Translator::checkAndSetLeaf(), isc::yang::Translator::checkAndSetUserContext(), isc::yang::Translator::setItem(), and isc::yang::Translator::setMandatoryLeaf().

Referenced by setOptionDef().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_option_def.h
- translator_option_def.cc